# NOTE
# - release notes: https://github.com/memcached/memcached/wiki/ReleaseNotes
# TODO
# - fix x32 build failure:
#crawler.c: In function 'crawler_metadump_eval':
#crawler.c:229:13: warning: format '%ld' expects argument of type 'long int', but argument 5 has type 'time_t {aka long long int}' [-Wformat=]
#             "key=%s exp=%ld la=%llu cas=%llu fetch=%s\n",
#             ^
#crawler.c:229:13: warning: format '%ld' expects argument of type 'long int', but argument 5 has type 'time_t {aka long long int}' [-Wformat=]

Summary:	A high-performance, distributed memory object caching system
Summary(pl.UTF-8):	Rozproszony, wysokiej wydajności system cache'owania obiektów
Name:		memcached
Version:	1.5.20
Release:	2
License:	BSD
Group:		Networking/Daemons
Source0:	http://www.memcached.org/files/%{name}-%{version}.tar.gz
# Source0-md5:	4b64296ea0eeccdee9168c035e0488ab
Source1:	%{name}.init
Source2:	%{name}.sysconfig
Source3:	%{name}.tmpfiles
URL:		https://memcached.org/about
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	libevent-devel >= 1.1
BuildRequires:	rpmbuild(macros) >= 1.268
BuildRequires:	sed >= 4.0
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/groupdel
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Requires:	rc-scripts >= 0.4.1.23
Provides:	group(memcached)
Provides:	user(memcached)
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_bindir	%{_sbindir}

%description
A high-performance, distributed memory object caching system.

%description -l pl.UTF-8
Rozproszony, wysokiej wydajności system cache'owania obiektów.

%package devel
Summary:	Files needed for development using memcached protocol
Group:		Development/Libraries
# does not require base

%description devel
Install memcached-devel if you are developing C/C++ applications that
require access to the memcached binary include files.

%prep
%setup -q

sed -nie '1,/^$/p' ChangeLog

%ifarch x32
%{__sed} -i -e 's/-Werror//' configure.ac
%endif

%build
%{__aclocal}
%{__autoconf}
%{__autoheader}
%{__automake}
%configure \
	%{?with_repcached:--enable-replication} \
	--disable-coverage
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/etc/{rc.d/init.d,sysconfig},/var/run/memcached} \
	$RPM_BUILD_ROOT%{systemdtmpfilesdir}

%{__make} install \
	INSTALL="%{__install} -p" \
	DESTDIR=$RPM_BUILD_ROOT

install -p %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
cp -p %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/%{name}
cp -p %{SOURCE3} $RPM_BUILD_ROOT%{systemdtmpfilesdir}/%{name}.conf

%pre
%groupadd -g 209 %{name}
%useradd -u 209 -d /usr/share/empty -g %{name} -c "Memcached Daemon" %{name}

%post
/sbin/chkconfig --add %{name}
%service %{name} restart

%preun
if [ "$1" = "0" ]; then
	%service -q %{name} stop
	/sbin/chkconfig --del %{name}
fi

%postun
if [ "$1" = "0" ]; then
	%userremove %{name}
	%groupremove %{name}
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc AUTHORS README.md ChangeLog doc/*.txt
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/%{name}
%attr(754,root,root) /etc/rc.d/init.d/%{name}
%attr(755,root,root) %{_sbindir}/%{name}
%{_mandir}/man1/memcached.1*
%dir %attr(770,root,memcached) /var/run/memcached
%{systemdtmpfilesdir}/%{name}.conf

%files devel
%defattr(644,root,root,755)
%{_includedir}/%{name}
%changelog
* Sat Feb 08 2020 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/memcached.git;a=log;h=master

* Sat Feb 08 2020 Jan Rękorajski <baggins@pld-linux.org> d92bb55
- rebuild with libevent 2.1.11
- release 2 (by relup.sh)

* Tue Nov 12 2019 Sławomir Paszkiewicz <paszczus@pld-linux.org> 42a6147
- updated to 1.5.20

* Tue Oct 01 2019 Adam Gołębiowski <adamg@pld-linux.org> 1851747
- updated to 1.5.19 (1.5.14 solves CVE-2019-11596, 1.5.17 solves CVE-2019-15026)

* Tue Apr 16 2019 Adam Gołębiowski <adamg@pld-linux.org> 0161e2c
- updated to 1.5.13

* Fri Dec 28 2018 Elan Ruusamäe <glen@pld-linux.org> 528eaeb
- disable udp in default config to avoid memcrashed aplification attacks

* Fri Dec 28 2018 Elan Ruusamäe <glen@pld-linux.org> 6fb2252
- up to 1.5.12 - https://github.com/memcached/memcached/wiki/ReleaseNotes1512

* Fri Dec 28 2018 Elan Ruusamäe <glen@pld-linux.org> 1d01bb0
- up to 1.5.11 (2018-10-10)

* Wed Oct 10 2018 Adam Gołębiowski <adamg@pld-linux.org> 53b8e34
- updated to 1.5.10

* Sat Mar 10 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 3a0ecac
- up to 1.5.6

* Sat Dec 16 2017 Elan Ruusamäe <glen@pld-linux.org> b99c21a
- up to 1.4.39

* Tue Apr 25 2017 Elan Ruusamäe <glen@delfi.ee> dacfa27
- up to 1.4.36; drop repcached patch (unmaintained)

* Sun Apr 02 2017 Jan Rękorajski <baggins@pld-linux.org> 040242e
- rebuild with libevent 2.1.9
- release 2 (by relup.sh)

* Wed Nov 23 2016 Elan Ruusamäe <glen@delfi.ee> 947a497
- use make install; add -devel package

* Wed Nov 23 2016 Elan Ruusamäe <glen@delfi.ee> 70b0f7e
- workaround x32 -Werror

* Tue Nov 22 2016 Elan Ruusamäe <glen@delfi.ee> e63ff5d
- up to 1.4.33

* Mon Apr 27 2015 Elan Ruusamäe <glen@delfi.ee> 3980cd4
- up to 1.4.24; build fails on x32

* Wed Apr 22 2015 Elan Ruusamäe <glen@delfi.ee> a1b62f2
- up to 1.4.23

* Tue May 13 2014 Elan Ruusamäe <glen@delfi.ee> cc074cd
- up to 1.4.20

* Wed Jan 01 2014 Elan Ruusamäe <glen@delfi.ee> 5628a20
- up to 1.4.17

* Mon Sep 30 2013 Elan Ruusamäe <glen@delfi.ee> f1cd211
- add link to release notes

